Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MXF.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MXF.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MXF.pm	(revision 34921)
@@ -37,6 +37,7 @@
 use vars qw($VERSION);
 use Image::ExifTool qw(:DataAccess :Utils);
-
-$VERSION = '1.02';
+use Image::ExifTool::GPS;
+
+$VERSION = '1.08';
 
 sub ProcessPrimer($$$);
@@ -58,5 +59,4 @@
     Lat => 1,       Timestamp => 1,
     Length => 1,    UID => 1,
-           
 );
 
@@ -79,14 +79,13 @@
 my %geoLat = (
     Groups => { 2 => 'Location' },
-    PrintConv => 'require Image::ExifTool::GPS; Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
+    PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
 );
 my %geoLon = (
     Groups => { 2 => 'Location' },
-    PrintConv => 'require Image::ExifTool::GPS; Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
+    PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
 );
 my %geoLatLon = (
     Groups => { 2 => 'Location' },
     PrintConv => q{
-        require Image::ExifTool::GPS;
         my ($lat, $lon) = split ' ', $val;
         $lat = Image::ExifTool::GPS::ToDMS($self, $lat, 1, 'N');
@@ -118,6 +117,5 @@
 %Image::ExifTool::MXF::Main = (
     GROUPS => { 2 => 'Video' },
-    PROCESS_PROC => 0,  # set this to zero to omit tags from lookup (way too many!)
-    VARS => { NO_ID => 1 }, # tag ID's are too bulky for documentation
+    VARS => { NO_LOOKUP => 1, NO_ID => 1 }, # tag ID's are too bulky
     NOTES => q{
         Tags extracted from Material Exchange Format files.  Tag ID's are not listed
@@ -268,6 +266,6 @@
   # '060e2b34.0101.0101.02080000.00000000' => { Name => 'Security', Type => 'Node' },
   # '060e2b34.0101.0101.02080100.00000000' => { Name => 'SystemAccess', Type => 'Node' },
-    '060e2b34.0101.0101.02080101.00000000' => { Name => 'Username', Format => 'string' },
-    '060e2b34.0101.0101.02080101.01000000' => { Name => 'Username', Type => 'UTF-16' },
+    '060e2b34.0101.0101.02080101.00000000' => { Name => 'UserName', Format => 'string' },
+    '060e2b34.0101.0101.02080101.01000000' => { Name => 'UserName', Type => 'UTF-16' },
     '060e2b34.0101.0101.02080102.00000000' => { Name => 'Password', Format => 'string' },
     '060e2b34.0101.0101.02080102.01000000' => { Name => 'Password', Type => 'UTF-16' },
@@ -456,5 +454,5 @@
     '060e2b34.0101.0101.04010502.02000000' => { Name => 'ImageWidth', Format => 'int32u' }, # (renamed from StoredWidth)
   # '060e2b34.0101.0101.04010503.00000000' => { Name => 'DigitalQuantizationAndLevelParameters', Type => 'Node' },
-    '060e2b34.0101.0101.04010503.01000000' => { Name => 'BitsperPixel', Format => 'int8u' },
+    '060e2b34.0101.0101.04010503.01000000' => { Name => 'BitsPerPixel', Format => 'int8u' },
     '060e2b34.0101.0101.04010503.02000000' => { Name => 'RoundingMethodCode', Format => 'string' },
     '060e2b34.0101.0101.04010503.03000000' => { Name => 'BlackReferenceLevel', Format => 'int32u' },
@@ -785,5 +783,5 @@
     '060e2b34.0101.0101.07012001.10030100' => { Name => 'TelephoneNumber', Format => 'string' },
     '060e2b34.0101.0101.07012001.10030200' => { Name => 'FaxNumber', Format => 'string' },
-    '060e2b34.0101.0101.07012001.10030300' => { Name => 'E-MailAddress', Format => 'string' },
+    '060e2b34.0101.0101.07012001.10030300' => { Name => 'E-mailAddress', Format => 'string' },
   # '060e2b34.0101.0101.07012002.00000000' => { Name => 'PlaceDescriptions', Type => 'Node' },
     '060e2b34.0101.0101.07012002.01000000' => { Name => 'SettingDescription', Format => 'string' },
@@ -808,6 +806,6 @@
     '060e2b34.0101.0101.07020102.04010000' => { Name => 'TimecodeEndDateTime', Type => 'UILSBF', Unknown => 1, Groups => { 2 => 'Time' } },
   # '060e2b34.0101.0101.07020102.05000000' => { Name => 'MaterialOccurrenceTrueDateTime', Type => 'Node' },
-    '060e2b34.0101.0101.07020102.05010000' => { Name => 'UTCLastModifyDate', Format => 'string' },
-    '060e2b34.0101.0101.07020102.05020000' => { Name => 'LocalLastModifyDate', Format => 'string' },
+    '060e2b34.0101.0101.07020102.05010000' => { Name => 'UTCLastModifyDate', Format => 'string', Groups => { 2 => 'Time' } },
+    '060e2b34.0101.0101.07020102.05020000' => { Name => 'LocalLastModifyDate', Format => 'string', Groups => { 2 => 'Time' } },
   # '060e2b34.0101.0101.07020102.06000000' => { Name => 'MaterialOccurrenceTimeAddress', Type => 'Node' },
     '060e2b34.0101.0101.07020102.06010000' => { Name => 'TimecodeLastModifyDate', Type => 'UILSBF', Unknown => 1, Groups => { 2 => 'Time' } },
@@ -845,5 +843,5 @@
     '060e2b34.0101.0101.07020110.01020000' => { Name => 'TimecodeCreationDateTime', Type => 'UILSBF', Unknown => 1, Groups => { 2 => 'Time' } },
   # '060e2b34.0101.0101.07020110.02000000' => { Name => 'ModifyDate', Type => 'Node' },
-    '060e2b34.0101.0101.07020110.02010000' => { Name => 'LocalModifyDate', Format => 'string' },
+    '060e2b34.0101.0101.07020110.02010000' => { Name => 'LocalModifyDate', Format => 'string', Groups => { 2 => 'Time' } },
     '060e2b34.0101.0101.07020110.02020000' => { Name => 'TimecodeModifyDate', Type => 'UILSBF', Unknown => 1, Groups => { 2 => 'Time' } },
   # '060e2b34.0101.0101.07020200.00000000' => { Name => 'Durations', Type => 'Node' },
@@ -1062,5 +1060,5 @@
     '060e2b34.0101.0102.04010401.01000000' => { Name => 'AnalogVideoSystemName', Type => 'VideoSignalType', Unknown => 1 },
     '060e2b34.0101.0102.04010501.10000000' => { Name => 'VerticalSub-sampling', Format => 'int32u' },
-    '060e2b34.0101.0102.04010503.01010000' => { Name => 'BitsperPixel', Format => 'int32u' },
+    '060e2b34.0101.0102.04010503.01010000' => { Name => 'BitsPerPixel', Format => 'int32u' },
     '060e2b34.0101.0102.04010503.05000000' => { Name => 'ColorRangeLevels', Format => 'int32u' },
     '060e2b34.0101.0102.04010503.06000000' => { Name => 'PixelLayout', Type => 'RGBALayout', Unknown => 1 },
@@ -1357,5 +1355,5 @@
     '060e2b34.0101.0103.02080203.00000000' => { Name => 'ClassifiedBy', Format => 'string' },
     '060e2b34.0101.0103.02080204.00000000' => { Name => 'ClassificationReason', Format => 'string' },
-    '060e2b34.0101.0103.02080205.00000000' => { Name => 'DeclassificationDate', Format => 'string' },
+    '060e2b34.0101.0103.02080205.00000000' => { Name => 'DeclassificationDate', Format => 'string', Groups => { 2 => 'Time' } },
     '060e2b34.0101.0103.02080206.00000000' => { Name => 'DerivedFrom', Format => 'string' },
     '060e2b34.0101.0103.02080207.00000000' => { Name => 'ClassificationComment', Format => 'string' },
@@ -1367,5 +1365,5 @@
     '060e2b34.0101.0103.02300101.01000000' => { Name => 'NatureOfPersonality', Type => 'UTF-16' },
     '060e2b34.0101.0103.02300102.01010000' => { Name => 'ContributionStatus', Type => 'UTF-16' },
-    '060e2b34.0101.0103.02300103.01010000' => { Name => 'SupportorAdministrationStatus', Type => 'UTF-16' },
+    '060e2b34.0101.0103.02300103.01010000' => { Name => 'SupportOrAdministrationStatus', Type => 'UTF-16' },
     '060e2b34.0101.0103.02300201.01000000' => { Name => 'OrganizationKind', Type => 'UTF-16' },
     '060e2b34.0101.0103.02300202.01010000' => { Name => 'ProductionOrganizationRole', Type => 'UTF-16' },
@@ -1525,5 +1523,5 @@
     '060e2b34.0101.0103.07012001.10030101' => { Name => 'TelephoneNumber', Type => 'UTF-16' },
     '060e2b34.0101.0103.07012001.10030201' => { Name => 'FaxNumber', Type => 'UTF-16' },
-    '060e2b34.0101.0103.07012001.10030301' => { Name => 'E-MailAddress', Type => 'UTF-16' },
+    '060e2b34.0101.0103.07012001.10030301' => { Name => 'E-mailAddress', Type => 'UTF-16' },
     '060e2b34.0101.0103.07012002.01010000' => { Name => 'SettingDescription', Type => 'UTF-16' },
     '060e2b34.0101.0103.07020101.01050000' => { Name => 'POSIXMicroseconds', Format => 'int64u' },
@@ -2418,5 +2416,5 @@
 );
 
-# header information 
+# header information
 %Image::ExifTool::MXF::Header = (
     GROUPS => { 2 => 'Video' },
@@ -2479,10 +2477,10 @@
 sub ReadMXFValue($$$)
 {
-    my ($exifTool, $val, $type) = @_;
+    my ($et, $val, $type) = @_;
     my $len = length($val);
     local $_;
 
     if ($type eq 'UTF-16') {
-        $val = $exifTool->Decode($val, 'UCS2'); # (until we handle UTF-16 properly)
+        $val = $et->Decode($val, 'UCS2'); # (until we handle UTF-16 properly)
     } elsif ($type eq 'ProductVersion') {
         my @a = unpack('n*', $val);
@@ -2528,5 +2526,5 @@
         my ($count, $size) = unpack('NN', $val);
         # validate data length
-        $len == 8 + $count * $size or $exifTool->WarnOnce("Bad array or batch size");
+        $len == 8 + $count * $size or $et->WarnOnce("Bad array or batch size");
         my ($i, @a);
         for ($i=0; $i<$count; ++$i) {
@@ -2538,5 +2536,5 @@
             $_ = join('-', unpack('H8H4H4H4H12', $_)) foreach @a;
         } elsif ($type eq 'BatchOfUL' or $type =~ /^WeakReference/) {
-            $_ = ReadMXFValue($exifTool, $_, 'UL') foreach @a;
+            $_ = ReadMXFValue($et, $_, 'UL') foreach @a;
         }
         $val = \@a;
@@ -2571,5 +2569,5 @@
 sub ProcessPrimer($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $end = $$dirInfo{DirLen};
@@ -2578,7 +2576,7 @@
     my $size = Get32u($dataPt, 4);
     return 0 unless $size >= 18;
-    $exifTool->VerboseDir('MXF Primer', $count);
-    my $verbose = $exifTool->Options('Verbose');
-    my $primer = $$exifTool{MXFInfo}{Primer};
+    $et->VerboseDir('MXF Primer', $count);
+    my $verbose = $et->Options('Verbose');
+    my $primer = $$et{MXFInfo}{Primer};
     my $pos = 8;
     my $i;
@@ -2594,5 +2592,5 @@
         my $indx = $i . ')';
         $indx .= ' ' if length($indx) < 3;
-        $exifTool->VPrint(0, sprintf("  | $indx 0x%.4x => '$global'\n", $local));
+        $et->VPrint(0, sprintf("  | $indx 0x%.4x => '${global}'\n", $local));
     }
     return 1;
@@ -2605,14 +2603,14 @@
 sub ProcessLocalSet($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     local $_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos};
     my $end = $$dirInfo{DirLen};
-    my $mxfInfo = $$exifTool{MXFInfo};
+    my $mxfInfo = $$et{MXFInfo};
     my $primer = $$mxfInfo{Primer};
     my (@strongRef, @groups, $instance, $editRate, $trackID, $langCode, $textLang);
 
-    $exifTool->VerboseDir('MXF LocalSet', undef, $end);
+    $et->VerboseDir('MXF LocalSet', undef, $end);
 
     # loop through all tags in this local set
@@ -2629,5 +2627,5 @@
         } else {
             $tag = $loc;
-          # $exifTool->WarnOnce('Missing local key for at least one tag');
+          # $et->WarnOnce('Missing local key for at least one tag');
             $extra = ', NOT IN PRIMER!';
         }
@@ -2637,5 +2635,5 @@
             $type = $$tagInfo{Type};
             if ($type and $knownType{$type}) {
-                $val = ReadMXFValue($exifTool, substr($$dataPt, $pos, $len), $type);
+                $val = ReadMXFValue($et, substr($$dataPt, $pos, $len), $type);
                 push @strongRef, (ref $val ? @$val : $val) if $type =~ /^StrongReference/;
                 # remember instance UID of this local set
@@ -2651,10 +2649,10 @@
         }
         # get tagInfo ref the standard way to handle Unknown tags
-        $tagInfo = $langInfo || $exifTool->GetTagInfo($tagTablePtr, $tag);
+        $tagInfo = $langInfo || $et->GetTagInfo($tagTablePtr, $tag);
         # set Binary flag to extract all unknown-format tags as Binary data
         if ($tagInfo and $$tagInfo{Unknown} and not defined $$tagInfo{Binary}) {
             $$tagInfo{Binary} = not ($$tagInfo{Format} or ($type and $knownType{$type}));
         }
-        my $key = $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        my $key = $et->HandleTag($tagTablePtr, $tag, $val,
             Extra       => $extra,
             TagInfo     => $tagInfo,
@@ -2670,5 +2668,5 @@
         # (necessary because we don't have all the information we need
         #  to do this on the fly when the file is parsed linearly)
-        push @groups, $$exifTool{TAG_EXTRA}{$key};
+        push @groups, $$et{TAG_EXTRA}{$key};
         next unless $tagInfo;
         my $name = $$tagInfo{Name};
@@ -2676,9 +2674,9 @@
             $$mxfInfo{FixDuration}{$key} = 1;
         } elsif ($$tagInfo{LanguageCode}) {
-            $langCode = $$exifTool{VALUE}{$key};
+            $langCode = $$et{VALUE}{$key};
         } elsif ($name eq 'EditRate') {
-            $editRate = $$exifTool{VALUE}{$key};
+            $editRate = $$et{VALUE}{$key};
         } elsif ($name =~ /TrackID$/) {
-            $trackID = $$exifTool{VALUE}{$key};
+            $trackID = $$et{VALUE}{$key};
             unless ($$mxfInfo{Group1}{$trackID}) {
                 # save lookup to convert TrackID to our group 1 name
@@ -2702,5 +2700,5 @@
         # save instance UID's in groups hash (used to remove duplicates later)
         $$_{UID} = $instance foreach @groups;
-        $$objInfo{Name} = $$exifTool{DIR_NAME};
+        $$objInfo{Name} = $$et{DIR_NAME};
         $$objInfo{TrackID} = $trackID if defined $trackID;
         $$objInfo{EditRate} = $editRate if $editRate;
@@ -2720,5 +2718,5 @@
         }
         # save instance UID's of Preface's
-        push @{$$mxfInfo{Preface}}, $instance if $$exifTool{DIR_NAME} eq 'Preface';
+        push @{$$mxfInfo{Preface}}, $instance if $$et{DIR_NAME} eq 'Preface';
     }
     return 1;
@@ -2785,8 +2783,8 @@
 sub ConvertDurations($$)
 {
-    my ($exifTool, $mxfInfo) = @_;
-    my $valueHash = $$exifTool{VALUE};
-    my $infoHash = $$exifTool{TAG_INFO};
-    my $tagExtra = $$exifTool{TAG_EXTRA};
+    my ($et, $mxfInfo) = @_;
+    my $valueHash = $$et{VALUE};
+    my $infoHash = $$et{TAG_INFO};
+    my $tagExtra = $$et{TAG_EXTRA};
     my $editHash = $$mxfInfo{EditRate};
     my ($tag, $key, $i);
@@ -2809,8 +2807,8 @@
 sub ProcessMXF($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
-    my $unknown = $exifTool->Options('Unknown');
+    my $verbose = $et->Options('Verbose');
+    my $unknown = $et->Options('Unknown');
     my ($buff, $preface, $n, $headerEnd, $footerPos);
 
@@ -2820,7 +2818,7 @@
     my $start = pos($buff) - 11;
 
-    $exifTool->SetFileType();
+    $et->SetFileType();
     SetByteOrder('MM');
-    $raf->Seek($start, 0) or $exifTool->Warn('Seek error'), return 1;
+    $raf->Seek($start, 0) or $et->Warn('Seek error'), return 1;
     my $tagTablePtr = GetTagTable('Image::ExifTool::MXF::Main');
 
@@ -2835,8 +2833,8 @@
         Preface => [ ],     # instance UID's for all Preface objects
     );
-    $$exifTool{MXFInfo} = \%mxfInfo;
+    $$et{MXFInfo} = \%mxfInfo;
 
     # set group 1 name for all tags (so we can overwrite with track number later)
-    $$exifTool{SET_GROUP1} = 'MXF';
+    $$et{SET_GROUP1} = 'MXF';
 
     for (;;) {
@@ -2849,5 +2847,5 @@
             # skip directly to footer if possible
             if ($footerPos and $footerPos > $pos and (not $verbose or not $unknown)) {
-                $exifTool->VPrint(0, "[Skipping to footer. Use Unknown option to parse body partitions]\n");
+                $et->VPrint(0, "[Skipping to footer. Use Unknown option to parse body partitions]\n");
                 $raf->Seek($footerPos, 0) or last;
                 $pos = $footerPos;
@@ -2878,5 +2876,5 @@
             my $name = $1 eq '0d' ? 'UserOrganizationPublicUse' : 'Experimental';
             $tagInfo = { Name => $name, %localSet };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $ul, $tagInfo);
+            AddTagToTable($tagTablePtr, $ul, $tagInfo);
         }
         my ($val, $dataPt);
@@ -2895,5 +2893,5 @@
             $dataPt = \$buff;
             my $type = $$tagInfo{Type};
-            $val = ReadMXFValue($exifTool, $buff, $type) if $type and $knownType{$type};
+            $val = ReadMXFValue($et, $buff, $type) if $type and $knownType{$type};
         } elsif (($tagInfo and (not $$tagInfo{Unknown} or $unknown)) or $verbose) {
             if ($tagInfo) {
@@ -2922,5 +2920,5 @@
             next;
         }
-        $exifTool->HandleTag($tagTablePtr, $ul, $val,
+        $et->HandleTag($tagTablePtr, $ul, $val,
             TagInfo     => $tagInfo,
             DataPt      => $dataPt,
@@ -2932,14 +2930,14 @@
     # walk entire MXF object tree to fix family 1 group names
     my ($pathInfo, $tag, %did, %bestDur);
-    $pathInfo = { Path => [ 'MXF' ] } if $exifTool->Options('SavePath');
+    $pathInfo = { Path => [ 'MXF' ] } if $et->Options('SavePath');
     foreach $preface (@{$mxfInfo{Preface}}) {
         SetGroups(\%mxfInfo, $preface, $pathInfo);
     }
     # convert Duration values to seconds based on the appropriate EditRate
-    ConvertDurations($exifTool, \%mxfInfo);
+    ConvertDurations($et, \%mxfInfo);
 
     # remove tags to keep only the one from the most recent instance of the object
-    my $tagExtra = $$exifTool{TAG_EXTRA};
-    my $fileOrder = $$exifTool{FILE_ORDER};
+    my $tagExtra = $$et{TAG_EXTRA};
+    my $fileOrder = $$et{FILE_ORDER};
     # also determine our best Duration value
     if ($mxfInfo{BestDuration}) {
@@ -2954,11 +2952,11 @@
         my $utag = "$1 $instance";      # instance-specific tag name
         if ($did{$utag}) {
-            Image::ExifTool::DeleteTag($exifTool, $tag); # delete the duplicate
+            Image::ExifTool::DeleteTag($et, $tag); # delete the duplicate
         } else {
             $did{$utag} = 1;
             if ($bestDur{$utag}) {
                 # save best duration value
-                my $val = $$exifTool{VALUE}{$tag};
-                $exifTool->HandleTag($tagTablePtr, '060e2b34.0101.0102.07020201.01030000', $val);
+                my $val = $$et{VALUE}{$tag};
+                $et->HandleTag($tagTablePtr, '060e2b34.0101.0102.07020201.01030000', $val);
             }
         }
@@ -2966,6 +2964,6 @@
 
     # clean up and return
-    delete $$exifTool{SET_GROUP1};
-    delete $$exifTool{MXFInfo};
+    delete $$et{SET_GROUP1};
+    delete $$et{MXFInfo};
     return 1;
 }
@@ -2990,5 +2988,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
